package com.hive.communication.util;



public class CheckCode {


    // 计算校验码1（按位异或操作）
    public static byte calculateChecksum1(byte[] data) {
        byte checksum = 0x00;
        for (byte b : data) {
            checksum ^= b;
        }
        return checksum;
    }

    // 计算校验码2（加法操作）
    public static byte calculateChecksum2(byte[] data) {
        int sum = 0;
        for (byte b : data) {
            sum += b & 0xFF; // & 0xFF 保证每个 byte 被当作无符号处理
        }
        return (byte) (sum & 0xFF); // 取最后8位
    }

    // 将十六进制字符串转换为字节数组
    public static byte[] hexStringToByteArray(String s) {
        int len = s.length();
        byte[] data = new byte[len / 2];
        for (int i = 0; i < len; i += 2) {
            data[i / 2] = (byte) ((Character.digit(s.charAt(i), 16) << 4)
                    + Character.digit(s.charAt(i+1), 16));
        }
        return data;
    }
}
